﻿using System;
using ARKit;
using SceneKit;
using UIKit;

namespace ARApp.iOS
{
    public partial class ARViewController : UIViewController
    {

        ARSCNView sceneView;

        public ARViewController() : base("ARViewController", null)
        {
        }

        public void startAR()
        {
            sceneView = new ARSCNView();
            sceneView.Frame = View.Frame;
            View = sceneView;

            CreateARScene(sceneView);

            PositionScene(sceneView);
        }

        public override void ViewDidLoad ()
        {

            base.ViewDidLoad();

            startAR();
        }   


        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);

           

        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }

        public void CreateARScene(ARSCNView sceneView)
        {
            var scene = SCNScene.FromFile("art.scnassets/ship");

            sceneView.Scene = scene;

            //this is for debugging purpose
            sceneView.DebugOptions = ARSCNDebugOptions.ShowWorldOrigin
            | ARSCNDebugOptions.ShowFeaturePoints;

            sceneView.Session.Delegate = new ARSessionDelegate();
        }


        public void PositionScene(ARSCNView sceneView)
        {
            
            var configuration = new ARWorldTrackingConfiguration
            {
                PlaneDetection = ARPlaneDetection.Horizontal,
                LightEstimationEnabled = true
            };

            sceneView.Session.Run(configuration, ARSessionRunOptions.ResetTracking);


            var shipNode = sceneView.Scene.RootNode.FindChildNode("ship", true);


            shipNode.Position = new SCNVector3(0.0f, 0.0f, -20f);


            sceneView.Scene.RootNode.AddChildNode(shipNode);


            shipNode.RunAction(SCNAction.RepeatActionForever(SCNAction.RotateBy(0f, 4f, 0, 5)));
        }
    }
}

